from pydantic import BaseModel
from typing import List

from models.form import Form
from models.item import Item


class Solution(BaseModel):
    response_id: int
    forms: List[Form]
    
    def items_exist_in_forms(self, items: [Item]) -> bool:
        items_found = 0
        
        for item in items:
            for form in self.forms:
                if form.has_item(item):
                    items_found += 1
        
        return items_found
            
            
